/*
 * File:   luci.c
 * Author: mirko
 *
 * Created on September 25, 2014, 4:26 PM
 */

/******************************************************************************
 * Software License Agreement
 *
 * Copyright  2011 Microchip Technology Inc.  All rights reserved.
 * Microchip licenses to you the right to use, modify, copy and distribute
 * Software only when embedded on a Microchip microcontroller or digital
 * signal controller, which is integrated into your product or third party
 * product (pursuant to the sublicense terms in the accompanying license
 * agreement).
 *
 * You should refer to the license agreement accompanying this Software
 * for additional information regarding your rights and obligations.
 *
 * SOFTWARE AND DOCUMENTATION ARE PROVIDED ìAS ISî WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
 * OF MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR
 * PURPOSE. IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR
 * OBLIGATED UNDER CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION,
 * BREACH OF WARRANTY, OR OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT
 * DAMAGES OR EXPENSES INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL,
 * INDIRECT, PUNITIVE OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA,
 * COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY
 * CLAIMS BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF),
 * OR OTHER SIMILAR COSTS.
 *
 *****************************************************************************/


#include <p32xxxx.h>
#include <plib.h>               // Adds support for PIC32 Peripheral Library functions and macros
#include <proc/p32mx250f128b.h>


#pragma config FNOSC    = FRCPLL       	// Oscillator Select internal clock 8mhz
#pragma config FPLLIDIV = DIV_2        	// PLL Input Divider        => 8/2 = 4Mhz
#pragma config FPLLMUL  = MUL_20        // PLL Multiplier           => 4*20= 80Mhz
#pragma config FPLLODIV = DIV_2        	// PLL Output Divider       => 80/2= 40Mhz
#pragma config FPBDIV   = DIV_1         // Peripheral Clock divisor => 40/1= 40Mhz
#pragma config FWDTEN   = OFF          	// Watchdog Timer
#pragma config WDTPS    = PS1           			// Watchdog Timer Postscale
#pragma config FCKSM    = CSDCMD        			// Clock Switching & Fail Safe Clock Monitor
#pragma config OSCIOFNC = OFF           			// CLKO Enable
#pragma config POSCMOD  = OFF            			// Primary Oscillator
#pragma config IESO     = OFF           			// Internal/External Switch-over
#pragma config FSOSCEN  = OFF           			// Secondary Oscillator
#pragma config CP       = OFF           			// Code Protect
#pragma config BWP      = OFF           			// Boot Flash Write Protect
#pragma config PWP      = OFF           			// Program Flash Write Protect
#pragma config ICESEL   = ICS_PGx1      			// ICE/ICD Comm Channel Select
#pragma config DEBUG    = OFF           			// Debugger
#pragma config JTAGEN   = OFF

#define SYS_FREQ (40000000)

#define red0    LATBbits.LATB14     // led0
#define red1    LATAbits.LATA0      // led1
#define red2    LATBbits.LATB15     // led2
#define red3    LATAbits.LATA1      // led3
#define red4    LATBbits.LATB13     // led4

#define red5    LATBbits.LATB10

void DelayMs(unsigned int msec);

main(void){
mPORTASetPinsDigitalOut (BIT_0|BIT_1|BIT_4);
mPORTAClearBits  (BIT_0|BIT_1|BIT_4);

mPORTBSetPinsDigitalOut (BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5|BIT_7|BIT_8|BIT_9|BIT_10|BIT_11|BIT_13|BIT_14|BIT_15);
mPORTBClearBits  (BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5|BIT_7|BIT_8|BIT_9|BIT_10|BIT_11|BIT_13|BIT_14|BIT_15);

red5=1;

           while (1){
                     DelayMs(250);
                     red0=1;red4=0;
                     DelayMs(250);
                     red0=0;red1=1;
                     DelayMs(250);
                     red1=0;red2=1;
                     DelayMs(250);
                     red2=0;red3=1;
                     DelayMs(250);
                     red3=0;red4=1;
                    }
          }

void DelayMs(unsigned int msec){         // calcolando circa 2ms per msec=1
				unsigned int tWait, tStart;
				tWait=(SYS_FREQ/2000)*msec;
				tStart=ReadCoreTimer();
				while((ReadCoreTimer()-tStart)<tWait); 	// wait for the time to pass
				}


